//
// Script de gestion d'un Quota de temps quotidien d'utilisation d'une session
//
// Thierry WARROT, 2012
//


//
// Classes
//

//
// Classe TWScript
//

function TWScript()
{
   this.K_LEVEL_NORMAL = 0;
   this.K_LEVEL_DEBUG = 1;
   
   this._level = this.K_LEVEL_NORMAL;

	// Mthode
	this.setLevel = function (pLevel) {
	  this._level = pLevel;
	}
   
	// Mthode
	this.Echo = function (pText) {
	  if (this._level == this.K_LEVEL_DEBUG){
	     WScript.Echo(pText);
     }
     else {
      // RAF
     }
	}

	// Mthode
	this.MsgBox = function (pText) {
	  WScript.Echo(pText);
	}
}

//
// Classe MaxTimeData
//

function MaxTimeData(pMaxTimeDataFilePath)
{
	this._maxTimeDataFilePath = pMaxTimeDataFilePath;

	this._tempsMax = new Array(7);

	// Mthode readFile
	this.readFile = function () {
		// Ouvrir le fichier en lecture
		var f = g_fso.OpenTextFile(pMaxTimeDataFilePath, 1, true);

		for (i=0; i<7; i++){
			this._tempsMax[i] = parseInt(f.ReadLine());
		}      

		f.Close();
	}
}

//
// Classe LoginTimeData
//

function LoginTimeData(pLoginDataFilePath)
{
	this._loginDataFilePath = pLoginDataFilePath;

	this._dateEnregistree = new Date();
	this._minDejaConsoAuLogin = 0;
	this._minConsoDepuisLogin = 0;
	this._minDejaConsoAuLoginAMettreAJ = 0;

	// Mthode readFile
	this.readFile = function () {
		// Ouvrir le fichier en lecture
		var f = g_fso.OpenTextFile(pLoginDataFilePath, 1, true);

		this._dateEnregistree = new Date(f.ReadLine());
		this._minDejaConsoAuLogin = parseInt(f.ReadLine());
		this._minConsoDepuisLogin = parseInt(f.ReadLine());
		this._minDejaConsoAuLoginAMettreAJ = f.ReadLine();

		f.Close();
	}

	// Mthode writeFile
	this.writeFile = function () {
		// Ouvrir le fichier en criture
		var f = g_fso.OpenTextFile(pLoginDataFilePath, 2, true);

		f.WriteLine(this._dateEnregistree);
		f.WriteLine(this._minDejaConsoAuLogin);
		f.WriteLine(this._minConsoDepuisLogin);
		f.WriteLine(this._minDejaConsoAuLoginAMettreAJ);

		f.Close();
	}
}

//
// Fonctions
//

function getLastLoginTime(pUserLogin)
{
	var objNetwork = WScript.CreateObject("WScript.Network"); // = net user
	// var strCurrentLoginName = objNetwork.username;
	var strDomain = objNetwork.UserDomain;

	var objUser = GetObject("WinNT://" + strDomain + "/" + pUserLogin + ",user");

	return objUser.LastLogin;
}


function manageShutdown(pUserLogin, pLoginDataFilePath, pAllowedTimeFilePath){
	var objNetwork = WScript.CreateObject("WScript.Network"); // = net user
	var currentLoginName = objNetwork.username;

	if (pUserLogin == currentLoginName) {
		if (! g_fso.FileExists(pLoginDataFilePath))
		{
			// Infos lues dans le fichier
			var timeData = new LoginTimeData(pLoginDataFilePath);

			// Ecrire les donnes dans le fichier
			timeData.writeFile();
		}

		if (! g_fso.FileExists(pLoginDataFilePath))
		{
			WScript.Echo("ERREUR : " + pLoginDataFilePath + " introuvable.");
		}
		else
		{
			// Date courante  00:00:00.000
			var todayDate = new Date();
			todayDate.setHours(0);
			todayDate.setMinutes(0);
			todayDate.setSeconds(0);
			todayDate.setMilliseconds(0);

			var minConsoDepuisLogin;

			// Infos lues dans le fichier
			var maxTimeData = new MaxTimeData(pAllowedTimeFilePath);
			maxTimeData.readFile();
			var tempsMax = maxTimeData._tempsMax[(todayDate.getDay()+6)%7];

			// Infos lues dans le fichier
			var timeData = new LoginTimeData(pLoginDataFilePath);
			timeData.readFile();

			//
			// Vrification du changement de jour
			//

			if (todayDate.valueOf() == timeData._dateEnregistree.valueOf()) {
				// On n'a pas chang de jour

				// RAF
			}
			else {
				// On a chang de jour

				// mmoriser le nouveau jour
				timeData._dateEnregistree = todayDate

				timeData._minDejaConsoAuLogin = 0;

				// lors de la prochaine session, pas besoin de mettre  jour la conso au login car elle vient d'tre mise  0
				timeData._minDejaConsoAuLoginAMettreAJ=0;
			}
			gTWScript.Echo("minutes dj consomme au login : " + timeData._minDejaConsoAuLogin);


			//
			// Gestion du changement ventuel de session
			//

			// Heure courante
			var dateCourante = new Date();

			// Heure du dernier login
			var lastLoginDate = new Date(getLastLoginTime(pUserLogin));

			// minutes consommes = Heure courante - Heure Login
			var minConsoDepuisLogin = Math.floor((dateCourante.getTime() - lastLoginDate.getTime())/1000/60);
			gTWScript.Echo("minutes consommes depuis le login calcules: " + minConsoDepuisLogin);
			gTWScript.Echo("minutes consommes depuis le login enregistres : " + timeData._minDejaConsoAuLogin);

			if (minConsoDepuisLogin >= K_SEUIL){
				// La session a dmarr depuis un certain temps : on est dans notre session "en cours"

				// Indiquer que lors de la prochaine session, il faudra mettre  jour la conso
				timeData._minDejaConsoAuLoginAMettreAJ=1;
			}
			else
			{
				// On est dans une nouvelle session qui vient de dmarrer

				if (timeData._minDejaConsoAuLoginAMettreAJ == 1){
					// Il faut mmoriser les minutes dj consommes au dmarrage de la session

					// Ajouter au min dj consommes au login celles consommes lors de la session prcdente
					timeData._minDejaConsoAuLogin = timeData._minDejaConsoAuLogin + timeData._minConsoDepuisLogin;

					// Indiquer que la mmorisation a t faite
					timeData._minDejaConsoAuLoginAMettreAJ=0;
				} 
			}

			timeData._minConsoDepuisLogin = minConsoDepuisLogin;

			// Sauvegarder les infos
			timeData.writeFile();



			//
			// Vrification du dpassement de quota
			//

			// Indiquer combien de temps il reste
			var cumulConso = timeData._minDejaConsoAuLogin + minConsoDepuisLogin;
			gTWScript.Echo("cumulConso : " + cumulConso);

			gTWScript.Echo("Minutes max : " + tempsMax);
			if (cumulConso < tempsMax) {
				// il reste du temps

    			if (cumulConso + 5 == tempsMax) {
    				// On est  5' de l'expiration
    
//			      gTWScript.MsgBox("CheckTimeQuota : Fermeture de la session dans 5 minutes !");
    			}
			}
			else {
				// Le quota de temps est consomm

				// shutdown immdiat
				gTWScript.Echo("shutdown...");

				g_Shell.Exec("C:\\WINDOWS\\system32\\shutdown.exe -l");    		
			}
		}
	}
	else
	{
		// Il n'y a pas  monitorer la session de l'utilisateur courant

		// RAF
	}
}

// *************************************************
// *****M A I N ************************************
// *************************************************
// **files.js loginName UsedTimeFilePath MaxTimeFilePath**************
// *************************************************

if (WScript.Arguments.length < 3) {
   WScript.Echo("Usage : loginName UsedTimeFilePath MaxTimeFilePath [debugLevel]");
}
else {
   var K_TEMPS_MAX_PAR_JOUR = 60; // en minutes
   var K_SEUIL = 2; // en minutes
   
   var g_fso = new ActiveXObject("Scripting.FileSystemObject");
   var g_Shell = WScript.CreateObject("WSCript.shell");
   
   var gTWScript = new TWScript();
   
   var loginName = WScript.Arguments(0);
   var UsedTimeFilePath = WScript.Arguments(1);
   var MaxTimeFilePath = WScript.Arguments(2);

   if (WScript.Arguments.length == 4) {
      gTWScript.setLevel(WScript.Arguments(3));
   }
   else {
      // RAF
   }
   
   gTWScript.Echo("Dbut");
   
   // Exemple : manageShutdown("thierry", "D:\\LoginData.txt", "D:\\MaxAllowedTime.txt");
   manageShutdown(loginName, UsedTimeFilePath, MaxTimeFilePath);
   
   gTWScript.Echo("Fin");
   
   g_fso=null;
   g_Shell=null;
   
   gTWScript=null;
}
